'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _validatorjs = require('validatorjs');

var _validatorjs2 = _interopRequireDefault(_validatorjs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Form = function (_React$Component) {
  _inherits(Form, _React$Component);

  function Form(_ref) {
    var initialValues = _ref.initialValues;

    _classCallCheck(this, Form);

    var _this = _possibleConstructorReturn(this, (Form.__proto__ || Object.getPrototypeOf(Form)).call(this));

    _this.state = { values: initialValues || {}, errors: {} };
    _this.onChange = _this.onChange.bind(_this);
    _this.validate = _this.validate.bind(_this);
    _this.onBlur = _this.onBlur.bind(_this);
    return _this;
  }

  _createClass(Form, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(_ref2) {
      var errors = _ref2.errors,
          initialValues = _ref2.initialValues;

      if (initialValues !== this.props.initialValues) this.setState({ initialValues: initialValues });

      if (errors !== this.props.errors) this.setState({ errors: errors });
    }
  }, {
    key: 'validate',
    value: function validate(onClick) {
      var rules = this.props.rules;
      var values = this.state.values;

      if (!rules) return onClick(values);

      var runner = new _validatorjs2.default(values, rules);

      if (runner.fails()) {
        return this.setState({ errors: runner.errors.errors });
      } else this.setState({ errors: {} });

      return onClick(values);
    }
  }, {
    key: 'onBlur',
    value: function onBlur(name) {
      var rules = this.props.rules;
      var _state = this.state,
          errors = _state.errors,
          values = _state.values;

      if (!rules || !rules[name]) return;

      var runner = new _validatorjs2.default(_defineProperty({}, name, values[name]), _defineProperty({}, name, rules[name]));

      if (runner.fails() && values[name]) {
        return this.setState({ errors: _extends({}, errors, runner.errors.errors) });
      }
      if (errors[name]) return this.setState({ errors: _extends({}, errors, _defineProperty({}, name, null)) });
    }
  }, {
    key: 'onChange',
    value: function onChange(_ref5) {
      var target = _ref5.target;
      var values = this.state.values;

      values[target.name] = target.value;
      this.setState({ values: values });
    }
  }, {
    key: 'renderChildren',
    value: function renderChildren(children) {
      var _this2 = this;

      return _react2.default.Children.map(children, function (child) {
        if (!child || !child.props) return child;
        if (child.props.children) return _this2.renderChildren(child.props.children);

        var _state2 = _this2.state,
            values = _state2.values,
            errors = _state2.errors;


        if (child.props.name) return _react2.default.cloneElement(child, {
          onChange: _this2.onChange,
          onBlur: function onBlur() {
            return _this2.onBlur(child.props.name);
          },
          error: errors[child.props.name] && typeof errors[child.props.name] !== 'string' ? errors[child.props.name][0] : errors[child.props.name] || '',
          value: values[child.props.name] || ''
        });

        if (child.props.submit) {
          var _child$props = child.props,
              submit = _child$props.submit,
              otherProps = _objectWithoutProperties(_child$props, ['submit']);

          return _react2.default.createElement(child.type, _extends({}, otherProps, {
            onClick: function onClick() {
              return _this2.validate(child.props.onClick);
            }
          }));
        }
        return child;
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          rules = _props.rules,
          initialValues = _props.initialValues,
          props = _objectWithoutProperties(_props, ['children', 'rules', 'initialValues']);

      return _react2.default.createElement(
        'div',
        props,
        this.renderChildren(children)
      );
    }
  }]);

  return Form;
}(_react2.default.Component);

exports.default = Form;